package mysqlbug;

// CREATE TABLE document (docid INT(10) UNSIGNED KEY AUTO_INCREMENT, dockey VARCHAR(32) NOT NULL) DEFAULT CHARACTER SET utf8 ENGINE=InnoDB;
// CREATE TABLE field (docid INT(10) UNSIGNED NOT NULL, field_name VARCHAR(128) NOT NULL, field_string VARCHAR(255) NOT NULL, PRIMARY KEY (docid,field_name) ,FOREIGN KEY (docid) REFERENCES DOCUMENT(docid) ON DELETE CASCADE) DEFAULT CHARACTER SET utf8 ENGINE=InnoDB;

// Dropping the FK constraint shows the error as a Deadlock
// ALTER TABLE field DROP FOREIGN KEY field_ibfk_1;

public class Driver {

	private static final int NUM_THREADS = 5;	//  2 are enough for the problem to appear, but takes a little longer

	public static void main(String[] args) {
		for(int i = 0; i < NUM_THREADS; i++) {
			InserterThread t = new InserterThread(i);
			t.start();
		}
	}

}
