package mysqlbug;

import java.sql.Connection;
import java.sql.DriverManager;

public final class DB {

	private static DB _inst; 
	
	private DB() {
		// prevent instantiation
	}
	
	public static DB getInstance() {
		if( null == _inst ) {
			_inst = new DB();
		}
		return _inst;
	}
	
	public Connection getConnection() {
		try {
			Class.forName("com.mysql.jdbc.Driver");
			Connection c = DriverManager.getConnection("jdbc:mysql://localhost/mysqlbug", "autoforms", "autoforms");
			// PROBLEM OCCURS IN ALL ISOLATION LEVELS; CHANGE THIS TO BE SURE
//			c.setTransactionIsolation(Connection.TRANSACTION_REPEATABLE_READ);
			c.setAutoCommit(false);
			return c;
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}

}